#undef UNICODE

#include <Windows.h>
#include <ScrnSave.h>
#include <CommCtrl.h>
#include <math.h>
#include "resource.h"

#pragma comment(lib, "Scrnsave")
#pragma comment(lib, "comctl32")

#define M_PI 3.14159265358979323846
#define scr_name "Spining cube"
#define scr_auth "kaimi.ru"

#pragma pack(push, 1)
static struct
{
	union
	{
		DWORD settings;
		struct
		{
			BYTE r;
			BYTE g;
			BYTE b;
			BYTE pos;
		};
	};
} scr_settings;
#pragma pack(pop)

void LoadSaveSettings(BOOL do_save)
{
	HKEY key;
	DWORD disposition;
	DWORD type = REG_DWORD, size = sizeof(REG_DWORD);

	if(RegCreateKeyEx(HKEY_CURRENT_USER, "Software\\Sample\\SimpleScreenSaver", 0, NULL, 0, KEY_WRITE | KEY_READ, NULL, &key, &disposition) == ERROR_SUCCESS)
	{
		if(do_save)
			RegSetValueEx(key, "Settings", 0, type, (PBYTE)&scr_settings.settings, size);
		else
			RegQueryValueEx(key, "Settings", NULL, &type, (PBYTE)&scr_settings.settings, &size);
		
		RegCloseKey(key);
	}
}

LONG WINAPI ScreenSaverProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	static HDC hDC;
	static HPEN hPen;
	static UINT timer_id;
	static RECT rect;
	static PAINTSTRUCT ps = {0};

	static double s[360], c[360];
	static double lO[12][2][4], lR[12][2][4];

	static int side_size = 500;
	static int xCenter = 0, yCenter = 0, zCenter = 0;
	static int theta = 0, phi = 0;
	static int thetaRot = 2, phiRot = 2;
	
	static double scrX[12][2], scrY[12][2];

	static int i;

	switch(message)
	{
		case WM_CREATE:
			LoadSaveSettings(FALSE);
			hPen = CreatePen(PS_SOLID, 5, RGB(scr_settings.r, scr_settings.g, scr_settings.b));

			xCenter = GetSystemMetrics (SM_CXSCREEN) / 2;
			yCenter = GetSystemMetrics (SM_CYSCREEN) / 2;
			zCenter = xCenter + yCenter - 4;

			rect.left = xCenter - side_size;
			rect.top = yCenter - side_size;
			rect.right = xCenter + side_size;
			rect.bottom = yCenter + side_size;


			for(i = 0; i < 360; i++)
			{
				s[i] = sin(i * (M_PI / 180));
				c[i] = cos(i * (M_PI / 180));
			}

			lO[0][0][0] = -side_size; lO[0][0][1] = side_size; lO[0][0][2] = side_size;
			lO[0][1][0] = side_size;  lO[0][1][1] = side_size; lO[0][1][2] = side_size;

			lO[1][0][0] = side_size; lO[1][0][1] = -side_size; lO[1][0][2] = side_size;
			lO[1][1][0] = side_size; lO[1][1][1] = side_size;  lO[1][1][2] = side_size;

			lO[2][0][0] = side_size; lO[2][0][1] = side_size; lO[2][0][2] = -side_size;
			lO[2][1][0] = side_size; lO[2][1][1] = side_size; lO[2][1][2] = side_size;

			lO[3][0][0] = -side_size; lO[3][0][1] = -side_size; lO[3][0][2] = side_size;
			lO[3][1][0] = -side_size; lO[3][1][1] = side_size;  lO[3][1][2] = side_size;

			lO[4][0][0] = -side_size; lO[4][0][1] = side_size; lO[4][0][2] = -side_size;
			lO[4][1][0] = -side_size; lO[4][1][1] = side_size; lO[4][1][2] = side_size;

			lO[5][0][0] = -side_size; lO[5][0][1] = -side_size; lO[5][0][2] = side_size;
			lO[5][1][0] = side_size;  lO[5][1][1] = -side_size; lO[5][1][2] = side_size;

			lO[6][0][0] = -side_size; lO[6][0][1] = side_size; lO[6][0][2] = -side_size;
			lO[6][1][0] = side_size;  lO[6][1][1] = side_size; lO[6][1][2] = -side_size;

			lO[7][0][0] = -side_size; lO[7][0][1] = -side_size; lO[7][0][2] = -side_size;
			lO[7][1][0] = side_size;  lO[7][1][1] = -side_size; lO[7][1][2] = -side_size;

			lO[8][0][0] = -side_size; lO[8][0][1] = -side_size; lO[8][0][2] = -side_size;
			lO[8][1][0] = -side_size; lO[8][1][1] = side_size;  lO[8][1][2] = -side_size;

			lO[9][0][0] = side_size; lO[9][0][1] = -side_size; lO[9][0][2] = -side_size;
			lO[9][1][0] = side_size; lO[9][1][1] = -side_size; lO[9][1][2] = side_size;

			lO[10][0][0] = side_size; lO[10][0][1] = -side_size; lO[10][0][2] = -side_size;
			lO[10][1][0] = side_size; lO[10][1][1] = side_size;  lO[10][1][2] = -side_size;

			lO[11][0][0] = -side_size; lO[11][0][1] = -side_size; lO[11][0][2] = -side_size;
			lO[11][1][0] = -side_size; lO[11][1][1] = -side_size; lO[11][1][2] = side_size;
			
			timer_id = SetTimer(hWnd, 1, 500 - 5 * scr_settings.pos + 1, NULL);

		break;

		case WM_DESTROY:
			if(timer_id)
				KillTimer(hWnd, timer_id);

			if(hPen)
				DeleteObject(hPen);

			PostQuitMessage(0);
		break;

		case WM_TIMER:
				for(i = 0; i < 12; i++)
				{
					lR[i][0][0] = -lO[i][0][0] * s[theta] + lO[i][0][1] * c[theta];
					lR[i][0][1] = -lO[i][0][0] * c[theta] * s[phi] - lO[i][0][1] * s[theta] * s[phi] - lO[i][0][2] * c[phi] + 1;
					lR[i][0][2] = -lO[i][0][0] * c[theta] * c[phi] - lO[i][0][1] * s[theta] * c[phi] + lO[i][0][2] * s[phi];

					lR[i][1][0] = -lO[i][1][0] * s[theta] + lO[i][1][1] * c[theta];
					lR[i][1][1] = -lO[i][1][0] * c[theta] * s[phi] - lO[i][1][1] * s[theta] * s[phi] - lO[i][1][2] * c[phi] + 1;
					lR[i][1][2] = -lO[i][1][0] * c[theta] * c[phi] - lO[i][1][1] * s[theta] * c[phi] + lO[i][1][2] * s[phi];


					if(lR[i][0][2] + zCenter > 0 || lR[i][0][2] + zCenter < 0)
					{
						scrX[i][0] = 256 * (lR[i][0][0] / (lR[i][0][2] + zCenter)) + xCenter;
						scrY[i][0] = 256 * (lR[i][0][1] / (lR[i][0][2] + zCenter)) + yCenter;
					}

					if(lR[i][1][2] + zCenter > 0 || lR[i][1][2] + zCenter < 0)
					{
						scrX[i][1] = 256 * (lR[i][1][0] / (lR[i][1][2] + zCenter)) + xCenter;
						scrY[i][1] = 256 * (lR[i][1][1] / (lR[i][1][2] + zCenter)) + yCenter;
					}
				}
				
				InvalidateRect(hWnd, &rect, TRUE);
		break;

		case WM_PAINT:
				
				hDC = BeginPaint(hWnd, &ps);
				
				if(!fChildPreview)
				{
					SelectObject(hDC, hPen);
					for(i = 0; i < 12; i++)
					{
						MoveToEx(hDC, (int)scrX[i][0], (int)scrY[i][0], NULL);
						LineTo(hDC, (int)scrX[i][1], (int)scrY[i][1]);
					}

					theta = (theta + thetaRot) % 360;
					phi = (phi + phiRot) % 360;
				}
				else
				{
					SetBkColor(hDC, RGB(0, 0, 0));
					SetTextColor(hDC, RGB(0, 255, 0));
					TextOut(hDC, 35, 30, scr_name, strlen(scr_name));
					TextOut(hDC, 50, 50, scr_auth, strlen(scr_auth));
				}

				EndPaint(hWnd, &ps);
		break;

		default:
			return DefScreenSaverProc(hWnd, message, wParam, lParam);
	}

	return 0;
}

BOOL WINAPI ScreenSaverConfigureDialog(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch(message)
	{
		case WM_INITDIALOG:
			LoadSaveSettings(FALSE);
			
			SendDlgItemMessage(hDlg, SPIN_SLIDER, TBM_SETPOS, TRUE, scr_settings.pos);
			SetDlgItemInt(hDlg, R_EDIT, scr_settings.r, FALSE);
			SetDlgItemInt(hDlg, G_EDIT, scr_settings.g, FALSE);
			SetDlgItemInt(hDlg, B_EDIT, scr_settings.b, FALSE);

			SendDlgItemMessage(hDlg, R_SPIN, UDM_SETRANGE32, 0, 255);
			SendDlgItemMessage(hDlg, G_SPIN, UDM_SETRANGE32, 0, 255);
			SendDlgItemMessage(hDlg, B_SPIN, UDM_SETRANGE32, 0, 255);
			
			SendDlgItemMessage(hDlg, R_SPIN, UDM_SETBUDDY, (WPARAM) GetDlgItem(hDlg, R_EDIT), 0);
			SendDlgItemMessage(hDlg, G_SPIN, UDM_SETBUDDY, (WPARAM) GetDlgItem(hDlg, G_EDIT), 0);
			SendDlgItemMessage(hDlg, B_SPIN, UDM_SETBUDDY, (WPARAM) GetDlgItem(hDlg, B_EDIT), 0);

		return TRUE;
		
		case WM_COMMAND:
			switch(LOWORD(wParam))
			{
				case IDOK:
					scr_settings.pos = (BYTE)SendDlgItemMessage(hDlg, SPIN_SLIDER, TBM_GETPOS, 0, 0);
					scr_settings.r = GetDlgItemInt(hDlg, R_EDIT, NULL, FALSE);
					scr_settings.g = GetDlgItemInt(hDlg, G_EDIT, NULL, FALSE);
					scr_settings.b = GetDlgItemInt(hDlg, B_EDIT, NULL, FALSE);
					LoadSaveSettings(TRUE);

					EndDialog(hDlg, LOWORD(wParam));
				break;
				case IDCANCEL:
					EndDialog(hDlg, LOWORD(wParam));
				break;
			}
		return TRUE;
	}

	return FALSE;
}

BOOL WINAPI RegisterDialogClasses(HANDLE hInst)
{
	return TRUE;
}